#ifndef AMICHECK_H
#define AMICHECK_H
/**********************************************************************
* amiCheck.h
*
* global externs for system-wide routines and variables
*
***********************************************************************/
#include <libraries/amigaguide.h>
#include <clib/intuition_protos.h>
#include <clib/asl_protos.h>
#include <proto/amigaguide.h>
#include <clib/amigaguide_protos.h>
#include <clib/alib_protos.h>
#include <libraries/amigaguide.h>


#include "dataBase.h"

#define __USE_SYSBASE
#include <libraries/guifront.h>
#include <proto/guifront.h>

#define FILEPATTERN_SIZE	30

#define AmigaGuideSignal(x) 	((x)?AmigaGuideSignal(x):0)

extern char currFile[FILESIZE];
extern char currStr[AMNTSIZE+1];
extern char stateStr[AMNTSIZE+1];
extern char filtStr[AMNTSIZE+1];
extern char filePattern[FILEPATTERN_SIZE];
extern char importPattern[FILEPATTERN_SIZE];
extern char scriptPattern[FILEPATTERN_SIZE];
extern char netPattern[FILEPATTERN_SIZE];
extern struct Library *GUIFrontBase;
extern struct Library *AmigaGuideBase;
extern GUIFrontApp *guiapp;
extern GUIFront *gui;
extern ExtErrorData exterr;
extern char *iconPath;
extern BOOL autosort;
extern BOOL amidone;
extern BOOL seldone;
extern UBYTE dclicktype;
extern struct Menu *menuStrip;
extern BOOL simpleRefresh;
extern STRPTR AC_Version;
extern STRPTR AC_Author;
extern struct Window *amiWindow;

extern struct FileRequester *otherRexxASL, *netsaveASL, *netloadASL, *scriptASL,
	*scriptsaveASL, *reportASL, *devASL, *loadASL;

extern AMIGAGUIDECONTEXT agc;
extern BOOL amigaguide;
__far extern char *guideLinks[];

/* guide help links */
#define HELP_KEY	0x5f

enum {
	MAIN_PANEL,
	SELTEMP_PANEL,
	NEWTEMP_PANEL,
	EDITTEMP_PANEL,
	FILTER_PANEL,
	SORT_PANEL,
	ANALYSIS_PANEL,
	FORMS_PANEL,
	ENTRY_PANEL,
	RECONCILE_PANEL,
	ACCOUNT_PANEL,
	SEARCH_PANEL,
	CAT_PANEL,
	STATS_PANEL,
	REPORT_PANEL,
	SCRIPT_PANEL,
	QUICKMEMO_PANEL,
	QUICKDATE_PANEL,
	QUICKNAME_PANEL,
	QUICKAMNT_PANEL,
	MEMO_PANEL,
	AMNT_PANEL,
	NAME_PANEL,
	NET_PANEL,
	PRINT_PANEL,
	GROUP_PANEL,
	AREXX_PANEL,
	KEY_PANEL,
};

void AmiDisableSel(BOOL);
void AmiUpdateState(char *);
void AmiUpdateCurr(char *);
void AmiUpdateFilt(char *);
void AmiMoveSwap(void);
void AmiLock(void);
void AmiUnlock(void);
void AmiEnterData(void);
void AmiNewTemp(void);
BOOL AmiSave(char *, BOOL);
BOOL AmiGetFile(GUIFront *gui, struct FileRequester *, char *, int); 
void AmiOpen(char *, BOOL);

void AmiBaseLink(char *);
void AmiHelpMsg(void);
void AmiHelpKey(struct IntuiMessage *imsg,ULONG panel);
void AmiAnnounce(char *);
#endif
