/* namePanel.c 
 *
 *  defines the GUIFront characteristics of the name panel 
 */
  
#include <exec/types.h>
#include <exec/lists.h>
#include <exec/nodes.h>
#include <exec/memory.h>
#include <clib/exec_protos.h>
#include <clib/alib_protos.h>
#include <clib/intuition_protos.h>
#include <stdio.h>  
#include <intuition/gadgetclass.h>
#include "amiCheck.h"
#include "dataBase.h"
#include "namePanel.h"
#include "regGadget.h"
#include <string.h>


/* prototypes */
BOOL NameHandleGadget(struct IntuiMessage *);
void NameInit(void);
void NameDisableGads(BOOL);

struct List tempnames;
BOOL updatename,nameretval;
ExtErrorData NameExtData;
GUIFront *nameGUI;
UWORD	namelistActive;
struct Window *nameWin;
BOOL updatenames = FALSE;

/* quick configure of some gadgets */
extern struct TagItem nameList[];

/* define gadgetspec */
GadgetSpec NAMEgadgetspecs[] = 
{
	{LISTVIEW_KIND,30,8, {0,0,0,0,NULL,NULL,GID_NAMELIST,
		PLACETEXT_ABOVE},nameList,GS_DefaultTags},

        {BUTTON_KIND,0,0,{0,0,0,0,"_New", NULL, GID_NAMENEW,         
                PLACETEXT_IN}, NULL, GS_DefaultTags},

        {BUTTON_KIND,0,0,{0,0,0,0,"_Remove", NULL, GID_NAMEDEL,         
                PLACETEXT_IN}, NULL, GS_DefaultTags},

        {STRING_KIND,20,0,{0,0,0,0,NULL, NULL, GID_NAMEEDIT,         
                PLACETEXT_IN}, NULL, GS_DefaultTags},

        {BUTTON_KIND,0,0,{0,0,0,0,"_Up", NULL, GID_NAMEUP,         
                PLACETEXT_IN}, NULL, GS_DefaultTags},

        {BUTTON_KIND,0,0,{0,0,0,0,"_Down", NULL, GID_NAMEDOWN,         
                PLACETEXT_IN}, NULL, GS_DefaultTags},

        {BUTTON_KIND,0,0,{0,0,0,0,"_Top", NULL, GID_NAMETOP,         
                PLACETEXT_IN}, NULL, GS_DefaultTags},

        {BUTTON_KIND,0,0,{0,0,0,0,"_Bottom", NULL, GID_NAMEBOTTOM,         
                PLACETEXT_IN}, NULL, GS_DefaultTags},

        {BUTTON_KIND,0,0,{0,0,0,0,"_OK", NULL, GID_NAMEOK,         
                PLACETEXT_IN}, NULL, GS_DefaultTags},

        {BUTTON_KIND,0,0,{0,0,0,0,"_Cancel", NULL, GID_NAMECANCEL,        
                PLACETEXT_IN}, NULL, GS_DefaultTags},
 
};

struct TagItem nameList[] =
{
        {GTLV_ShowSelected, &NAMEgadgetspecs[GID_NAMEEDIT]},
                /*
	{GTLV_Labels, ~0},
	{GTLV_Selected,~0},
        */
        {TAG_DONE},
};

/* set up array of pointers to our specs */
GadgetSpec *N_NameSpecs[] =
{
        &NAMEgadgetspecs[0],
        &NAMEgadgetspecs[1],
        &NAMEgadgetspecs[2],
        &NAMEgadgetspecs[3],
        &NAMEgadgetspecs[4],
        &NAMEgadgetspecs[5],
        &NAMEgadgetspecs[6],
        &NAMEgadgetspecs[7],
        &NAMEgadgetspecs[8],
        &NAMEgadgetspecs[9],
        NULL,
};


/* define the layout of this panel */
ULONG N_NamePanel[] =
{
   GUIL_Flags, GUILF_PropShare | GUILF_EqualWidth,

   GUIL_HorizGroup, 1,
        GUIL_Flags, GUILF_PropShare,
	GUIL_FrameType, GUILFT_Recess,
        
	GUIL_VertGroup, 1,

		GUIL_HorizGroup,1,
			GUIL_FrameType, GUILFT_Ridge,
			GUIL_GadgetSpecID, GID_NAMELIST,

                	GUIL_VertGroup,1,
                        	GUIL_Flags, GUILF_PropShare | GUILF_EqualWidth | GUILF_EqualHeight,
                                              
				GUIL_GadgetSpecID, GID_NAMEUP,
				GUIL_GadgetSpecID, GID_NAMEDOWN,
				GUIL_GadgetSpecID, GID_NAMETOP,
				GUIL_GadgetSpecID, GID_NAMEBOTTOM,
                	TAG_DONE,

		TAG_DONE,
	
		GUIL_HorizGroup,1,
			GUIL_FrameType, GUILFT_Ridge,
			GUIL_Flags, GUILF_EqualSize | GUILF_EqualWidth,
			GUIL_GadgetSpecID, GID_NAMEDEL,
			GUIL_GadgetSpecID, GID_NAMENEW,
		TAG_DONE,

	TAG_DONE,
        
    TAG_DONE,
    
    GUIL_HorizGroup,1,
        GUIL_Flags, GUILF_EqualSize | GUILF_EqualWidth,
        
           GUIL_GadgetSpecID, GID_NAMEOK,
           GUIL_GadgetSpecID, GID_NAMECANCEL,
           
    TAG_DONE,   
           
TAG_DONE,
};


/****************************************************
* NameGUI ()
*
*	Creates the GUI for the edit temp panel.
*****************************************************/
BOOL NameGUI(void)
{
 BOOL done = FALSE;
 BOOL noreply;
 UWORD ordinal;
 ULONG signal;
     
   AmiLock();

   /* install temporary list */
   NewList(&tempnames);
   DataCopyList(&namelist, &tempnames, NameNewEdit);

   updatename = FALSE;

		GF_SetGUIAttr(nameGUI, GUI_OpenGUI, TRUE, TAG_DONE);
 		/* grab window */
 		GF_GetGUIAttr(nameGUI,GUI_Window,&nameWin,TAG_DONE);
		NameInit();


                /* Process input events */
                while (!done)
                {
                    struct IntuiMessage *imsg;

                    /* Wait for an event to occur */

                    signal = GF_Wait(guiapp,AmigaGuideSignal(agc));
		    if (signal & AmigaGuideSignal(agc)) {
			AmiHelpMsg();
			continue;
		    }

                    /* We only bother to listen for CLOSEWINDOW events.
                     * Of course, in a real application, you would be
                     * examining the Class field for IDCMP_GADGETUP
                     * messages and act accordingly.
                     */

                    while (imsg = GF_GetIMsg(guiapp))
                    {
			noreply = TRUE;
                        switch (imsg->Class) {
				case IDCMP_REFRESHWINDOW:
					RegRefresh(TRUE);
					break;

                                case IDCMP_CLOSEWINDOW:
					DataFreeList(&tempnames);
                                        done = TRUE;
                                        break;

				case IDCMP_RAWKEY:
					if (GF_ProcessListView(nameGUI,N_NameSpecs[GID_NAMELIST],
						imsg,&ordinal)) {
							namelistActive = ordinal;
							NameDisableGads(FALSE);	
					}
					AmiHelpKey(imsg,NAME_PANEL);
					break;

				case IDCMP_GADGETUP:
					noreply = FALSE;
					done=NameHandleGadget(imsg);
					break;
                        }
                                     
                              
                        if (noreply) GF_ReplyIMsg(imsg);
                    }
                }

   
   GF_SetGadgetAttrs(nameGUI,NAMEgadgetspecs[GID_NAMELIST].gs_Gadget,
			GTLV_Labels, ~0,
			TAG_DONE);
   GF_SetGUIAttr(nameGUI, GUI_OpenGUI, FALSE, TAG_DONE);
   if (updatename == TRUE) {
	     DataMoveList(&tempnames, &namelist);
	     NewList(&tempnames);
   }

  AmiUnlock();
  return (nameretval);
}

/***************************************************
* NameHandleGadget()
*
*	Handles gadget events for this panel
****************************************************/
BOOL  NameHandleGadget(struct IntuiMessage *imsg)
{
 BOOL done = FALSE;
 struct Gadget *gad = (struct Gadget *)(imsg->IAddress);
 UWORD code = imsg->Code;
 nameNode tempname;
 nameNode *temp;

 switch (gad->GadgetID) {
	
	case GID_NAMELIST:
		namelistActive = code;
		NameDisableGads(FALSE);
		break;

	case GID_NAMEEDIT:
		if (namelistActive != ~0) {
		  if (DataIsUnique(nameGUI, &tempnames,((struct StringInfo*)gad->SpecialInfo)->Buffer,
			TRUE,"Name name is not unique or invalid") ) {

			/* detach and modify this */
			temp = (nameNode*)DataOrd2Node(&tempnames,namelistActive);
			GF_SetGadgetAttrs(nameGUI,NAMEgadgetspecs[GID_NAMELIST].gs_Gadget,
				GTLV_Labels, ~0,
				TAG_DONE);
			
			strcpy(temp->nameStr, ((struct StringInfo*)gad->SpecialInfo)->Buffer);
			GF_SetGadgetAttrs(nameGUI,NAMEgadgetspecs[GID_NAMELIST].gs_Gadget,
				GTLV_Labels, &tempnames,
				TAG_DONE);	
		  }
		  else {
			DataSitNSpin(N_NameSpecs[GID_NAMEEDIT]->gs_Gadget,nameWin);
			return (done);
		  }
		}
		break;

	case GID_NAMENEW:
		strcpy(tempname.nameStr,"NEW:RENAME ME");
		if (DataIsUnique(nameGUI, &tempnames,tempname.nameStr,TRUE,"You must rename the previous entry first")){
			/* detach and modify list */
			GF_SetGadgetAttrs(nameGUI,NAMEgadgetspecs[GID_NAMELIST].gs_Gadget,
				GTLV_Labels, ~0,
				TAG_DONE);
			
			temp=NameNewEdit(&tempnames,&tempname);
			namelistActive = DataNode2Ord(&tempnames,temp->nameStr);
					
			GF_SetGadgetAttrs(nameGUI,NAMEgadgetspecs[GID_NAMELIST].gs_Gadget,
				GTLV_Labels, &tempnames,
				GTLV_Selected, namelistActive,
				TAG_DONE);	

			NameDisableGads(FALSE);
		}
		break;

	case GID_NAMEDEL:
		DataListRemove(nameGUI,NAMEgadgetspecs[GID_NAMELIST].gs_Gadget,
			&tempnames, &namelistActive);

		/* disable up/down? */
		if (IsListEmpty(&tempnames))
			NameDisableGads(TRUE);
		break;

	case GID_NAMEUP:
		DataListUp(nameGUI,NAMEgadgetspecs[GID_NAMELIST].gs_Gadget,
			&tempnames, &namelistActive);
		break;

	case GID_NAMEDOWN:
		DataListDown(nameGUI,NAMEgadgetspecs[GID_NAMELIST].gs_Gadget,
			&tempnames, &namelistActive);
		break;

	case GID_NAMETOP:
		DataListTop(nameGUI,NAMEgadgetspecs[GID_NAMELIST].gs_Gadget,
			&tempnames, &namelistActive,0);
		break;

	case GID_NAMEBOTTOM:
		DataListBottom(nameGUI,NAMEgadgetspecs[GID_NAMELIST].gs_Gadget,
			&tempnames, &namelistActive,DataCountNodes(&tempnames));
		break;

	case GID_NAMECANCEL:
		DataFreeList(&tempnames);
		done = TRUE;
		break;

	case GID_NAMEOK:
		amiChangedItems = TRUE;
		updatename = done = TRUE;	
		break;
 }

 GF_ReplyIMsg(imsg);
 return (done);
}

/****************************************************
* NameInit()
*
*	Set up some globals
*****************************************************/
void NameInit(void)
{
	nameretval = FALSE;
	namelistActive = ~0;	

 /* grab window */
 GF_GetGUIAttr(nameGUI,GUI_Window,&nameWin,TAG_DONE);
 GF_SetGadgetAttrs(nameGUI,NAMEgadgetspecs[GID_NAMELIST].gs_Gadget,
			GTLV_Labels, &tempnames,
			GTLV_Selected,~0,
			TAG_DONE);
 NameDisableGads(TRUE);
}

/****************************************************
* NameDisableGads()
*
*	Disable/Enable extra gadgets
*****************************************************/
void NameDisableGads(BOOL dis)
{
 GF_SetGadgetAttrs(nameGUI,NAMEgadgetspecs[GID_NAMEDEL].gs_Gadget,
	GA_Disabled, dis,
	TAG_DONE);

 GF_SetGadgetAttrs(nameGUI,NAMEgadgetspecs[GID_NAMEUP].gs_Gadget,
	GA_Disabled, dis,
	TAG_DONE);

 GF_SetGadgetAttrs(nameGUI,NAMEgadgetspecs[GID_NAMEDOWN].gs_Gadget,
	GA_Disabled, dis,
	TAG_DONE);

 GF_SetGadgetAttrs(nameGUI,NAMEgadgetspecs[GID_NAMETOP].gs_Gadget,
	GA_Disabled, dis,
	TAG_DONE);

 GF_SetGadgetAttrs(nameGUI,NAMEgadgetspecs[GID_NAMEBOTTOM].gs_Gadget,
	GA_Disabled, dis,
	TAG_DONE);
}

/*************************************************************
* NameNewEdit()
*
*	Creates a new name node and places it at tail
**************************************************************/
nameNode *NameNewEdit(struct List *el,nameNode *m)
{
 nameNode *work;

 work = (nameNode *)AllocVec(sizeof(nameNode), MEMF_CLEAR);
 strcpy(work->nameStr,m->nameStr);
 work->node.ln_Name = work->nameStr;
 AddTail((struct List *)el,(struct Node *)work);
 return (work);
}
