#ifndef REGGADGET_H
#define REGGADGET_H

/************************************************************************
*   regGadget.h:
*   global externs for the register gadget
*   
*************************************************************************/
#include "dataBase.h"

/* movement keys */
#define UP		0
#define DOWN		1
#define SHIFTUP		2
#define SHIFTDOWN	3
#define CTRLUP		4
#define CTRLDOWN	5

/*
 * vars
 */
extern ULONG numVisible;        /* number of entries shown in list */
extern ULONG selRow;            /* visibly selected item */  
extern ULONG regTopRow;		/* top row of register */
extern UWORD entryCount;
extern BOOL showMemo;
 
/*
 * prototypes
 */
 
BOOL RegInit(void);
void RegFreeAll(void);
void RegRefresh(BOOL);
BOOL RegHitTest(ULONG, ULONG, ULONG, ULONG);
void RegClearGrid(void);
void RegRenderCell(ULONG,ULONG,char *, char, long *, BOOL);
void RegAddEntry(filterNode *);
void RegInsertEntry(UWORD,filterNode *);
void RegRenderCellFlush(ULONG,ULONG,char *, char, long *);
void RegKeyScroll(UWORD);
void RegMoveList(struct MinList *,UWORD);
void RegScrollListUp(void);
void RegScrollListDown(void);
void RegRedrawSel(filterNode *);
void RegEditDisable(BOOL);
void RegRemoveSel(void);
void RegNewFilter(void);
void RegMoveToSel(struct MinList *);
void RegRedrawRow(filterNode *);
void RegSwapMemo(void);
void RegSelect(ULONG, BOOL);
void RegResetOffsets(int);
void RegRedrawFilter(ULONG);

#endif
